function DeepCopy(orig)
	local orig_type = type(orig)
	local copy

	if orig_type == 'table' then
		copy = {}

		for orig_key, orig_value in next, orig, nil do
			copy[DeepCopy(orig_key)] = DeepCopy(orig_value)
		end

		setmetatable(copy, DeepCopy(getmetatable(orig)))
	else
		copy = orig
	end

	return copy
end

local MoveDefs = DeepCopy(DEFS.moveDefs)
local WeaponDefs = DeepCopy(DEFS.weaponDefs)

for moveName, moveData in pairs(MoveDefs) do
	moveData.footprintx = moveData.footprintx - 1
	moveData.footprintz = moveData.footprintx - 1
	moveData.heatmapping = false
	moveData.allowRawMovement = true
	moveData.avoidMobilesOnPath = false
	moveData.flowMapping = false
end

for name, wDef in pairs(WeaponDefs) do
	wDef.collideFriendly = false
	wDef.avoidFriendly = false
	wDef.avoidFeature = false
end

DEFS.weaponDefs = WeaponDefs
DEFS.moveDefs = MoveDefs