local CreateFeature = Spring.CreateFeature
local GetGroundHeight = Spring.GetGroundHeight
local DestroyFeature = Spring.DestroyFeature
local SetFeaturePosition = Spring.SetFeaturePosition

local vent = {
	clear = function(geoVents)
		for featureID in pairs(geoVents) do
			if geoVents[featureID] == true then
				SetFeaturePosition(featureID, 0, math.huge, 0, false)
				DestroyFeature(featureID)
				geoVents[featureID] = nil
			end
		end
	end,
	set = function(geoVents)
		local featureID

		for i = 1, #geoVents do
			local y = GetGroundHeight(geoVents[i].x, geoVents[i].z)
			featureID = CreateFeature("geovent", geoVents[i].x, y, geoVents[i].z)
			geoVents[featureID] = true
		end

		return featureID
	end
}

return vent